//+------------------------------------------------------------------+
//|                                                    drawtalib.mq4 |
//|                                                           isabek |
//+------------------------------------------------------------------+
#property copyright "isabek"
#property library
#define rbars 1

int dc, dd;
bool debug = false;
string trend[2];

int find24s(int &points24[][], int ip, int point1, int trend1, bool db) {
  int i, j;
  debug = db;

  //  3 
  dc = 0;
  for(i = point1-1; i > 0; i--) {
    if( i == getExtremum(i, trend1, rbars) ) {
      if( ((High[i]<=High[point1]) && trend1==0) || ((Low[i] >= Low[point1]) && trend1==1 )  ) {
        ip = addnew2(points24, ip, 1, 0, i, 0);//status, 2, 3, 4
        if(false) Print("3 : ", TimeToStr(Time[i]),".");
        dc++;
      } else {
        if ( ((High[i] > High[point1]) && trend1 == 0) || ((Low[i] < Low[point1]) && trend1 == 1 ) ) break;
      }
    }
  }
  if(debug) Print(" 3 : ", dc,".");
  //if(debug) Print(ip);
  //if(dc == 0) return(8);
  
  //  -  1-3     1
  dc = 0;
  for(i=0; i<=ip; i++) {
    if(points24[i][0]==1) {
      if( point1 != getAbsoluteExtremum(point1+1, points24[i][3], trend1) ) {
        points24[i][0] = 0;
        dc++;
      }
    }
  }
  if(debug) Print("    . 1-3     1.: ", dc,".");
  //if(debug) Print(ip);

  //  2 
  dc = 0;
  int count = ip;
  for(i = 0; i<=count; i++) {
    if(points24[i][0] == 1) {
      for(j = point1-1; j > points24[i][3]; j--) { //         --  !!!!
        if( j == getExtremum(j, 1-trend1, rbars) ) {
          ip = addnew2(points24, ip, 2, j, points24[i][3], 0);
          dc++;
        }
      }
    }
  }
  if(debug) Print(" 2 : ", dc,".");
  //if(debug) Print(ip);
  //if(dc == 0) return(8);

  // 2 -  
  dc = 0;
  for(i=0; i<=ip; i++) {
    if(points24[i][0]==2) {
      if( points24[i][2] != getAbsoluteExtremum(point1, points24[i][3], 1-trend1) ) {
        points24[i][0] = 0;
        dc++;
      }
    }
  }
  if(debug) Print("  2   .2   .: ", dc,".");
  //if(debug) Print(ip);


  //  4 
  dc = 0;
  count = ip;
  for(i = 0; i<=count; i++) {
    if(points24[i][0] == 2) {
      for(j = points24[i][3]-1; j > 0; j--) {
        if( j == getExtremum(j, 1-trend1, rbars) ) {
          if( ((Low[j] <= Low[points24[i][2]]) && trend1==0) || ((High[j] >= High[points24[i][2]]) && trend1==1)) {
            ip = addnew2(points24, ip, 3, points24[i][2], points24[i][3], j);
            dc++;
          }
        }
      }
    }
  }
  if(debug) Print(" 4 : ", dc,".");
  //if(debug) Print(ip);
  //if(dc == 0) return(8);

  //   3  
  dc = 0;
  for(i=0; i<=ip; i++) {
    if(points24[i][0]==3) {
      if( points24[i][3] != getAbsoluteExtremum(points24[i][2], points24[i][4], trend1) ) {
        points24[i][0] = 0;
        dc++;
      }
    }
  }
  if(debug) Print("    .3  .: ", dc,".");
  //if(debug) Print(ip);
  
  if(debug) Print("------------->  : ",getCount(points24, ip, 3));
  debug = false;
  return(ip);
}

int getExtremum(int pointx, int updown, int ebars) {
  if(updown == 1) {
    return (iLowest(NULL, 0, MODE_LOW, ebars*2+1, pointx-ebars));
  }
  if(updown == 0) {
    return (iHighest(NULL, 0, MODE_HIGH, ebars*2+1, pointx-ebars));
  }
  return (-1);
}

int getAbsoluteExtremum(int from, int to, int updown) {
  if(updown == 1) {
    return (iLowest(NULL, 0, MODE_LOW, from-to+1, to));
  }
  if(updown == 0) {
    return (iHighest(NULL, 0, MODE_HIGH, from-to+1, to));
  }  
  return (-1);
}

int addnew2(int &points24[][], int ip, int status, int p2, int p3, int p4)
{
  ip++;
  int asize = ArrayRange(points24, 0);
  if(ip == asize) ArrayResize(points24, asize+10000);
  points24[ip][0] = status;
  points24[ip][1] = 0;
  points24[ip][2] = p2;
  points24[ip][3] = p3;
  points24[ip][4] = p4;
  return (ip);
}

int copyModels(int points24[][], int ip, int &models[][], double &sp[][], int im, int status, int p1) {
  for(int i=0; i<=ip; i++) {
    if(points24[i][0]==status) {
      im = addnew(models, sp, im, status, p1, points24[i][2], points24[i][3], points24[i][4], 0, 0, 0);
    }
  }
  return (im);
}

int addnew(int &models[][], double &sp[][], int im, int status, int p1, int p2, int p3, int p4, int p5, int p6, int p7)
{
  im++;
  int asize = ArrayRange(models, 0);
  if(im == asize) {
    ArrayResize(models, asize+10000);
    ArrayResize(sp, asize+10000);
  }
  models[im][0] = status;
  models[im][1] = p1;
  models[im][2] = p2;
  models[im][3] = p3;
  models[im][4] = p4;
  models[im][5] = p5;
  models[im][6] = p6;
  models[im][7] = p7;
  sp[im][0] = 0;
  sp[im][1] = 0;
  sp[im][2] = 0;
  sp[im][2] = 0;
  
  return (im);
}

void findMR(int &models[][], double &sp[][], int im, int trend1, bool db) {
  int i, j, local;
  double temp, temp2;
  trend[0] = "down";
  trend[1] = "up";
  debug = db;

  //   4  
  dc = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]==3) {
      temp = getValue2(models, i, trend1, "trend", models[i][4]);
      if ( ((temp <= Low[models[i][4]])&&(trend1==0) ) || ((temp >= High[models[i][4]])&&(trend1==1)) ){
        dc++;
        deleteModel(models, trend1, i);
      }
    }
  }
  if(debug) Print("    .4  .: ", dc,".");
  //if(getCount(models, im, 3)==0) return(8);

  //       
  dc = 0;
  bool deleted = false;
  for(i=0; i<=im; i++) {
    if(models[i][0]==3) {
      for(j = models[i][1]-1;j > models[i][3]; j--) {
        temp = getValue2(models, i, trend1, "trend", j);
        if (((temp <= High[j])&&(trend1==0) ) || ((temp >= Low[j])&&(trend1==1))) {             
          deleted = true;
          deleteModel(models, trend1, i);
          break;
        }
      }// 2  !
      for(j = models[i][3]-1;j > models[i][4]; j--) {
        temp = getValue2(models, i, trend1, "trend", j);
        if (((temp <= High[j])&&(trend1==0) ) || ((temp >= Low[j])&&(trend1==1))) {
          deleted = true;
          deleteModel(models, trend1, i);
          break;
        }
      }
      for(j = models[i][2]-1;j > models[i][4]; j--) {
        temp = getValue2(models, i, trend1, "target", j);
        if (((temp <= High[j])&&(trend1==1) ) || ((temp >= Low[j])&&(trend1==0))) {
          deleted = true;
          deleteModel(models, trend1, i);
          break;
        }
      }
      if (deleted) dc++;
      deleted = false;
    }
  }
  if(debug) Print("    .    .: ", dc,".");
  //if(getCount(models, im, 3)==0) return(8);

  //    
  dc = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]==3) {
      double prev = 0;
      double current = 0;
      for(j = models[i][2]-1;j > models[i][4]; j--) {
        temp = getValue2(models, i, trend1, "trend", j);
        temp2 = getValue2(models, i, trend1, "target", j);
        if (trend1==0) 
          current = temp - temp2;
        else 
          current = temp2 - temp;
        if (current < prev) {
          dc++;
          deleteModel(models, trend1, i);
          break;
        }
        prev = current;
      }
    }
  }
  if(debug) Print("    . .: ", dc,".");
  //if(getCount(models, im, 3)==0) return(8);


  //  
  dc = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]==3) {
      if(hasSP(models, sp, trend1, i)) {
        dc++;
      } else {
        deleteModel(models, trend1, i);
      }
    }
  }
  if(debug) Print(" : ", dc,".");
  //if(getCount(models, im, 3)==0) return(8);

  //      4 
  dc = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]==3) {
      for(j = models[i][4]-1;j > 0; j--) {
        temp = getValue2(models, i, trend1,  "trend", j);
        if (((temp <= High[j])&&(trend1==0) ) || ((temp >= Low[j])&&(trend1==1))) {
          models[i][7] = j;
          models[i][0] = 4; // !
          sp[i][3] = temp;
          sp[i][4] = getValue2(models, i, trend1,  "target", j);
          dc++;
          break;
        }
      }
    }
  }
  if(debug) Print("   (): ", dc,".");
  //if(getCount(models, im, 3)==0 && getCount(models, im, 4)==0) return(8);

  //    4?
  dc = 0;
  int end = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]>=3) {
      if (ismorethan2(models, trend1, i)) {
        end = models[i][4]-(StrToInteger(DoubleToStr(sp[i][1],0))-models[i][4])*2;
      } else {
        end = models[i][4]-(StrToInteger(DoubleToStr(sp[i][1],0))-models[i][4]);
      }
      
      if(debug) Print("  6 - ", TimeToStr(Time[end]));
      
      if (models[i][0]==4 && end < models[i][7]) end = models[i][7];

      if (end < 0) end = 0;

      local = getAbsoluteExtremum(models[i][4]-1, end, (1-trend1)); //    !!!
      if (local>=models[i][4]) {
        dc++;
        deleteModel(models, trend1, i);
      } else {
        if (((Low[models[i][4]] <= Low[local])&&(trend1==0) ) || ((High[models[i][4]] >= High[local])&&(trend1==1))) {
          dc++;
          deleteModel(models, trend1, i);
        } else {
          models[i][6] = local;
        }
      }
    }
  }
  if(debug) Print("    .   4.: ", dc,".");
  //if(getCount(models, im, 3)==0 && getCount(models, im, 4)==0) return(8);
  

  // 6   
  dc = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]>=3) {
      for(j = models[i][4]-1;j > models[i][6]; j--) {
        temp = getValue2(models, i, trend1, "trend", j);
        if (((temp <= High[j])&&(trend1==0) ) || ((temp >= Low[j])&&(trend1==1))) {
          dc++;
          deleteModel(models, trend1, i);
          break;
        }
      }

    }
  }
  if(debug) Print("    .6   .: ", dc,".");
  //if(getCount(models, im, 3)==0 && getCount(models, im, 4)==0) return(8);

  // 6     
  dc = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]==4) {
      if( models[i][6] != getAbsoluteExtremum(models[i][6], models[i][7], 1-trend1) ) {
        dc++;
        deleteModel(models, trend1, i);
      }
    }
  }
  if(debug) Print("    .6  .: ", dc,".");
  //if(getCount(models, im, 3)==0 && getCount(models, im, 4)==0) return(8);


  //  5? --- !!!!!!!!!
  dc = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]>=3) {
      local = getAbsoluteExtremum(models[i][4], models[i][6], trend1);
      if (local == -1 || local == models[i][4] || local == models[i][6]) {
        dc++;
        deleteModel(models, trend1, i);
      } else {
        models[i][5] = local;
      }
    }
  }
  if(debug) Print("    . 5.: ", dc,".");
  //if(getCount(models, im, 3)==0 && getCount(models, im, 4)==0) return(8);


  //   2  5  
  dc = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]>=3) {
      if( intersected(models[i][2], models[i][5]) ) {
        //linescolor = Green;//  
        dc++;
      }
    }
  }
  if(debug) Print("    .2  5  .: ", dc,".");
  // 25   !!!  !!! 24  !!!
  //  4-5  !
  //if(getCount(models, im, 3)==0 && getCount(models, im, 4)==0) return(8);

  //   
  dc = 0;
  dd = 0;
  for(i=0; i<=im; i++) {
    if(models[i][0]>=3) {
      if (getStrength(models, sp, i)>0) {
        dc++;
        sp[i][2] = 1; //c
      } else {
        dd++;
        sp[i][2] = 2; //c
      }
    }
  }
  if(debug) Print(" : ", dc,",  :", dd, ".");

  //   4 - 
  dc = 0;
  for (int check = 0; check<im; check++) {
    for(i=check+1; i<=im; i++) {
      if(models[i][0]>=3) {
      //Print("---", i);
        if ((models[i][1] == models[check][1]) && (models[i][2] == models[check][2]) && (models[i][3] == models[check][3]) && (models[i][5] == models[i][5])) {
          if ( ( (Low[models[i][4]] < Low[models[check][4]]) && (trend1==0) ) || ( (High[models[i][4]] > High[models[check][4]]) && (trend1==1) ) ) {
            deleteModel(models, trend1, check);
            //Print(check);
            dc++;
          }
        } else {
          check = i;
        }
      }
    }
  }
  if(debug) Print("    . 4  .: ", dc,".");
  //if(getCount(models, im, 3)==0) return(8);


}

double getValue2(int models[][], int model, int trend1, string type, int shift) {
  double diff;
  if (type == "trend") {
    if (trend1 == 0) {
      diff = High[models[model][1]]-High[models[model][3]];
      diff = diff/(models[model][1]-models[model][3]);
      diff = diff*(models[model][1]-shift);
      diff = High[models[model][1]]-diff;
      return(diff);
    } else {
      diff = Low[models[model][3]]-Low[models[model][1]];
      diff = diff/(models[model][1]-models[model][3]);
      diff = diff*(models[model][1]-shift);
      diff = Low[models[model][1]]+diff;
      return(diff);
    }
  } else {
    if (trend1 == 0) {
      diff = Low[models[model][2]]-Low[models[model][4]];
      diff = diff/(models[model][2]-models[model][4]);
      diff = diff*(models[model][2]-shift);
      diff = Low[models[model][2]]-diff;
      return(diff);
    } else {
      diff = High[models[model][4]]-High[models[model][2]];
      diff = diff/(models[model][2]-models[model][4]);
      diff = diff*(models[model][2]-shift);
      diff = High[models[model][2]]+diff;
      return(diff);
    }    
  }
}


void deleteModel(int &models[][], int trend1, int model) {
  ObjectDelete(getName(models, trend1, model, "trendline", models[model][1], models[model][3]));
  ObjectDelete(getName(models, trend1, model, "targetline", models[model][2], models[model][4]));
  models[model][0] = 0;
}

string getName(int models[][], int trend1, int model, string name, int pointA, int pointB) {
  return("tadv|"+models[model][1]+model+"["+TimeToStr(Time[models[model][1]])+"]"+"_"+trend[trend1]+"_" +name+"."+pointA+"."+pointB);
}

bool hasSP(int models[][], double &sp[][], int trend1, int model) {
  double prev, current, temp, temp2, ccc;
  prev = getValue2(models, model, trend1, "trend", models[model][2]);
  current = getValue2(models, model, trend1, "target", models[model][2]);  
  temp = getValue2(models, model, trend1, "trend", models[model][2]-1);
  temp2 = getValue2(models, model, trend1, "target", models[model][2]-1);
  if (((prev-temp)-(current-temp2)) == 0) ccc = 0;
  else ccc = MathRound(MathAbs((temp-temp2)/((prev-temp)-(current-temp2))));
  if(trend1==0) {
    sp[model][0] = (temp2+MathAbs(ccc*(current-temp2)));
  } else {
    sp[model][0] = (temp2-MathAbs(ccc*(current-temp2)));
  }
  sp[model][1] = ccc + models[model][2];
  return(true);
}

int getCount(int models[][], int im, int status) {
  int dc = 0;
  for(int i=0; i<=im; i++) {
    if(models[i][0]==status) {
      dc++;
    }
  }
  return (dc);
}

bool ismorethan2(int models[][], int trend1, int model) {
  int d=0;
  for(int j = models[model][1];j > models[model][4]; j--) {
    double temp = getValue2(models, model, trend1, "target", j);
    if (((temp >= Low[j])&&(trend1==0) ) || ((temp <= High[j])&&(trend1==1))) {             
      d++;
    }
  }
  if(d>1) 
    return (false);
  else
    return (true);
}

int getStrength(int models[][], double sp[][], int model) {
  int ct1, ct2;
  ct1 = sp[model][1]-models[model][1];
  ct2 = models[model][1]-models[model][3];
  return (ct1-ct2);
}

bool intersected(int bar1, int bar2) {
  double high1, low1, high2, low2;
  if (Open[bar1]>=Close[bar1]) {
    high1 = Open[bar1];
    low1 = Close[bar1];
  } else {
    high1 = Close[bar1];
    low1 = Open[bar1];
  }
  if (Open[bar2]>=Close[bar2]) {
    high2 = Open[bar2];
    low2 = Close[bar2];
  } else {
    high2 = Close[bar2];
    low2 = Open[bar2];
  }
  if (high1>=high2 && low1 <= low2) return (true);
  if (high1<=high2 && low1 >= low2) return (true);
  if (high1>=high2 && low1 >= low2 && low1 <= high2) return (true);
  if (high1<=high2 && low1 <= low2 &&  high1 >= low2) return (true);
  return(false);
}


